## qca2 2.3.10

=== plugins/CMakeLists.txt ===
# Use the same path for shared and static plugins
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}/crypto")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}/crypto")

set(PLUGINS "botan;cyrus-sasl;gcrypt;gnupg;logger;nss;ossl;pkcs11;softstore" CACHE INTERNAL "")

# Initialize WITH_${PLUGIN}_PLUGIN cache variables
foreach(PLUGIN IN LISTS PLUGINS)
  set(WITH_${PLUGIN}_PLUGIN "" CACHE STRING "Build ${PLUGIN} plugin")
  string(TOLOWER "${WITH_${PLUGIN}_PLUGIN}" WITH_${PLUGIN}_PLUGIN)
endforeach(PLUGIN IN LISTS PLUGINS)

string(REGEX MATCH "^none|all|auto$" NOT_PLUGIN_LIST "${BUILD_PLUGINS}")

if(NOT_PLUGIN_LIST)
  # BUILD_PLUGINS has "none", "all" or "auto" value
  foreach(PLUGIN IN LISTS PLUGINS)
    # If not defined by user use BUILD_PLUGINS value
    # to decide build or not build the plugin
    if("${WITH_${PLUGIN}_PLUGIN}" STREQUAL "")
      if("${BUILD_PLUGINS}" STREQUAL "all")
        set(WITH_${PLUGIN}_PLUGIN "yes")
      elseif("${BUILD_PLUGINS}" STREQUAL "auto")
        set(WITH_${PLUGIN}_PLUGIN "auto")
      else()
        set(WITH_${PLUGIN}_PLUGIN "no")
      endif()
    elseif(NOT WITH_${PLUGIN}_PLUGIN)
      set(WITH_${PLUGIN}_PLUGIN "no")
    elseif("${WITH_${PLUGIN}_PLUGIN}" STREQUAL "auto")
      set(WITH_${PLUGIN}_PLUGIN "auto")
    else()
      set(WITH_${PLUGIN}_PLUGIN "yes")
    endif()

    # Build plugin if yes or auto
    if(WITH_${PLUGIN}_PLUGIN)
      add_subdirectory("qca-${PLUGIN}")
    else()
      disable_plugin(${PLUGIN})
    endif()
  endforeach(PLUGIN IN LISTS PLUGINS)
else()
  # BUILD_PLUGINS has list plugins to builds
  foreach(PLUGIN IN LISTS PLUGINS)
    list(FIND BUILD_PLUGINS "${PLUGIN}" PLUGIN_INDEX)
    if(PLUGIN_INDEX GREATER -1)
      set(WITH_${PLUGIN}_PLUGIN "yes")
      add_subdirectory("qca-${PLUGIN}")
    else()
      disable_plugin(${PLUGIN})
    endif()
  endforeach(PLUGIN IN LISTS PLUGINS)
endif()

message("")
message("Plugins:")
foreach(PLUGIN IN LISTS PLUGINS)
  message("  qca-${PLUGIN} ${WITH_${PLUGIN}_PLUGIN_INTERNAL}")
endforeach(PLUGIN IN LISTS PLUGINS)

# Currently disabled
#
# IF (WIN32)
#         MESSAGE(STATUS "WinCrypto plugin enabled")
#         ADD_SUBDIRECTORY(qca-wincrypto)
# ENDIF (WIN32)

=== src/CMakeLists.txt ===
include(CheckIncludeFiles)
CHECK_INCLUDE_FILES(sys/filio.h HAVE_SYS_FILIO_H)
IF(HAVE_SYS_FILIO_H)
  ADD_DEFINITIONS(-DHAVE_SYS_FILIO_H)
ENDIF(HAVE_SYS_FILIO_H)

INCLUDE(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("
# include <stdlib.h>
# include <sys/mman.h>
int main() { void *f = 0; return mlock(f,8); }
" MLOCK_TAKES_VOID)
if(NOT MLOCK_TAKES_VOID)
  MESSAGE(STATUS "mlock(2) does not take a void *")
  ADD_DEFINITIONS(-DMLOCK_NOT_VOID_PTR)
endif()

if(DEVELOPER_MODE)
  add_definitions(-DQCA_PLUGIN_PATH="${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}")
else()
  if(USE_RELATIVE_PATHS)
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PREFIX_INSTALL_DIR}/${QCA_PLUGINS_INSTALL_DIR}")
  else()
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PLUGINS_INSTALL_DIR}")
  endif()
endif()

# base source files


SET( SOURCES
	qca_tools.cpp
	qca_plugin.cpp
	qca_textfilter.cpp
	qca_basic.cpp
	support/logger.cpp
	qca_cert.cpp
	qca_core.cpp
	qca_default.cpp
	qca_keystore.cpp
	qca_publickey.cpp
	qca_safeobj.cpp
	qca_safetimer.cpp
	qca_securelayer.cpp
	qca_securemessage.cpp
	support/qpipe.cpp
	support/console.cpp
	support/synchronizer.cpp
	support/dirwatch.cpp
	support/syncthread.cpp
)

IF (WIN32)
  SET( SOURCES ${SOURCES} qca_systemstore_win.cpp )
elseif(APPLE AND NOT IOS)
  set( SOURCES ${SOURCES} qca_systemstore_mac.cpp)
else()
  SET( SOURCES ${SOURCES} qca_systemstore_flatfile.cpp )
endif()

# Support files
#SET( qca_HEADERS ${qca_HEADERS} support/dirwatch/dirwatch_p.h )

# Botan tools
SET( botan_BASE botantools/botan )


INCLUDE_DIRECTORIES(support ${botan_BASE} )

ADD_DEFINITIONS(
	-DBOTAN_TYPES_QT
	-DBOTAN_NO_INIT_H
	-DBOTAN_NO_CONF_H
	-DBOTAN_TOOLS_ONLY
	-DBOTAN_MINIMAL_BIGINT
)

ADD_DEFINITIONS(
  -DBOTAN_MP_WORD_BITS=32
  -DBOTAN_KARAT_MUL_THRESHOLD=12
  -DBOTAN_KARAT_SQR_THRESHOLD=12
  -DBOTAN_EXT_MUTEX_QT
)

if(UNIX)
   ADD_DEFINITIONS( -DBOTAN_EXT_ALLOC_MMAP)
endif()

SET( botan_SOURCES
	${botan_BASE}/util.cpp
	${botan_BASE}/exceptn.cpp
	${botan_BASE}/mutex.cpp
	${botan_BASE}/mux_qt/mux_qt.cpp
	${botan_BASE}/charset.cpp
	${botan_BASE}/defalloc.cpp
	${botan_BASE}/mp_comba.cpp
	${botan_BASE}/mp_mul.cpp
	${botan_BASE}/mp_shift.cpp
	${botan_BASE}/mp_misc.cpp
	${botan_BASE}/divide.cpp
	${botan_BASE}/big_base.cpp
	${botan_BASE}/big_code.cpp
	${botan_BASE}/big_io.cpp
	${botan_BASE}/big_ops2.cpp
	${botan_BASE}/big_ops3.cpp
	${botan_BASE}/bit_ops.cpp
	${botan_BASE}/libstate.cpp
	${botan_BASE}/mem_pool.cpp
	${botan_BASE}/modules.cpp
	${botan_BASE}/mp_asm.cpp
	${botan_BASE}/mp_mulop.cpp
	${botan_BASE}/parsing.cpp
)

IF (UNIX)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_unix/mlock.cpp)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/alloc_mmap/mmap_mem.cpp)
ENDIF (UNIX)

IF(WIN32)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_win32/mlock.cpp)
ENDIF(WIN32)

SET( SOURCES ${SOURCES} ${botan_SOURCES})

add_library(${QCA_LIB_NAME} ${SOURCES}  ${public_HEADERS})
target_link_libraries(${QCA_LIB_NAME} PUBLIC Qt${QT_MAJOR_VERSION}::Core)
if(BUILD_WITH_QT6)
  target_link_libraries(${QCA_LIB_NAME} PRIVATE Qt6::Core5Compat)
endif()

if(WIN32)
	TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} PRIVATE crypt32 ws2_32)
endif()

if(APPLE AND NOT IOS)
  set(COREFOUNDATION_LIBRARY "-framework CoreFoundation")
  set(COREFOUNDATION_LIBRARY_SECURITY "-framework Security")
  TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} PRIVATE ${COREFOUNDATION_LIBRARY} ${COREFOUNDATION_LIBRARY_SECURITY})

  if(NOT USE_RELATIVE_PATHS)
    set_target_properties(${QCA_LIB_NAME} PROPERTIES
                          INSTALL_NAME_DIR "${QCA_LIBRARY_INSTALL_DIR}"
    )
  endif()
endif()

if(NOT ANDROID)
  set_target_properties(${QCA_LIB_NAME} PROPERTIES
                        VERSION ${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}
                        SOVERSION ${QCA_LIB_MAJOR_VERSION}
                        )
endif()

set_target_properties(${QCA_LIB_NAME} PROPERTIES
                      DEFINE_SYMBOL QCA_MAKEDLL
                      PUBLIC_HEADER "${public_HEADERS}"
                      FRAMEWORK ${OSX_FRAMEWORK}
                      FRAMEWORK_VERSION ${QCA_LIB_MAJOR_VERSION}
                      EXPORT_NAME ${QCA_LIB_NAME}
                      )

if(NOT DEVELOPER_MODE)
  # Do not split 'PUBLIC_HEADER ...' line. It means install headers to folder
  # and set this folder as -I flag for imported target.
  # Also EXPORT doesn't actually install any files. It only created a new target.
  install(TARGETS ${QCA_LIB_NAME} EXPORT ${QCA_CONFIG_NAME_BASE}Targets
          LIBRARY DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_BINARY_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          FRAMEWORK DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          PUBLIC_HEADER DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}" INCLUDES DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}"
  )
  install_pdb(${QCA_LIB_NAME} ${QCA_BINARY_INSTALL_DIR})
endif()

=== examples/md5crypt/CMakeLists.txt ===
set(md5crypt_bin_SRCS md5crypt.cpp)  

add_executable(md5crypt ${md5crypt_bin_SRCS})

target_link_qca_libraries(md5crypt)

#add "crypt" to the libs if you are trying the crypt() equivalent

=== examples/saslclient/CMakeLists.txt ===
set(saslclient_bin_SRCS saslclient.cpp)  

add_executable(saslclient ${saslclient_bin_SRCS})

target_link_qca_libraries(saslclient)
target_link_libraries(saslclient Qt${QT_MAJOR_VERSION}::Network)

=== examples/sslservtest/CMakeLists.txt ===
set(sslservtest_bin_SRCS sslservtest.cpp)  

add_executable(sslservtest ${sslservtest_bin_SRCS})

target_link_qca_libraries(sslservtest)
target_link_libraries(sslservtest Qt${QT_MAJOR_VERSION}::Network)

=== plugins/qca-gnupg/CMakeLists.txt ===
# QCA GnuPG

enable_plugin("gnupg")

set(QCA_GNUPG_SOURCES
  qca-gnupg.cpp
  gpgop.cpp
  utils.cpp
  gpgproc/sprocess.cpp
  mypgpkeycontext.cpp
  mykeystoreentry.cpp
  myopenpgpcontext.cpp
  mykeystorelist.cpp
  mymessagecontext.cpp
  ringwatch.cpp
  lineconverter.cpp
  gpgaction.cpp
  gpgproc/gpgproc.cpp
)

set(QCA_GNUPG_HEADERS
  gpgaction.h
  ringwatch.h
  gpgop.h
  gpgop_p.h
  lineconverter.h
  mypgpkeycontext.h
  mykeystoreentry.h
  mykeystorelist.h
  gpgproc/gpgproc_p.h
  gpgproc/sprocess.h
  gpgproc/gpgproc.h
  utils.h
  mymessagecontext.h
  myopenpgpcontext.h
)

add_library(qca-gnupg ${PLUGIN_TYPE} ${QCA_GNUPG_SOURCES} ${EXTRA_GNUPG_SOURCES} ${QCA_GNUPG_HEADERS})

if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
  set_property(TARGET qca-gnupg PROPERTY SUFFIX ".dylib")
endif()

include_directories(gpgproc)
target_link_libraries(qca-gnupg Qt${QT_MAJOR_VERSION}::Core ${QCA_LIB_NAME})

if (WIN32)
  target_link_libraries(qca-gnupg advapi32)
endif()

if(NOT DEVELOPER_MODE)
  install(TARGETS qca-gnupg DESTINATION
          LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

  install_pdb(qca-gnupg ${QCA_CRYPTO_INSTALL_DIR})
endif()

=== unittest/pkits/CMakeLists.txt ===
ENABLE_TESTING()

set(pkits_bin_SRCS pkits.cpp)

add_executable(pkits ${pkits_bin_SRCS} )

target_link_qca_test_libraries(pkits)


FOREACH( testFileName BadnotAfterDateCACert.crt RFC3280MandatoryAttributeTypesCACRL.crl BadnotAfterDateCACRL.crl
	 RFC3280OptionalAttributeTypesCACert.crt BadnotBeforeDateCACert.crt RFC3280OptionalAttributeTypesCACRL.crl
	 BadnotBeforeDateCACRL.crl RolloverfromPrintableStringtoUTF8StringCACert.crt BadSignedCACert.crt 
	 RolloverfromPrintableStringtoUTF8StringCACRL.crl BadSignedCACRL.crl TrustAnchorRootCertificate.crt
	 DSACACert.crt TrustAnchorRootCRL.crl DSACACRL.crl UIDCACert.crt DSAParametersInheritedCACert.crt
	 UIDCACRL.crl DSAParametersInheritedCACRL.crl UTF8StringCaseInsensitiveMatchCACert.crt
	 GoodCACert.crt UTF8StringCaseInsensitiveMatchCACRL.crl GoodCACRL.crl UTF8StringEncodedNamesCACert.crt
	 InvalidCAnotAfterDateTest5EE.crt UTF8StringEncodedNamesCACRL.crl InvalidCAnotBeforeDateTest1EE.crt
	 ValidCertificatePathTest1EE.crt InvalidCASignatureTest2EE.crt ValidDSAParameterInheritanceTest5EE.crt
	 InvalidDSASignatureTest6EE.crt ValidDSASignaturesTest4EE.crt
	 InvalidEEnotAfterDateTest6EE.crt ValidGeneralizedTimenotAfterDateTest8EE.crt
	 InvalidEEnotBeforeDateTest2EE.crt ValidGeneralizedTimenotBeforeDateTest4EE.crt
	 InvalidEESignatureTest3EE.crt ValidNameChainingCapitalizationTest5EE.crt
	 InvalidMissingCRLTest1EE.crt ValidNameChainingWhitespaceTest3EE.crt
	 InvalidNameChainingOrderTest2EE.crt ValidNameChainingWhitespaceTest4EE.crt
	 InvalidNameChainingTest1EE.crt ValidNameUIDsTest6EE.crt
	 Invalidpre2000UTCEEnotAfterDateTest7EE.crt Validpre2000UTCnotBeforeDateTest3EE.crt
	 InvalidRevokedCATest2EE.crt ValidRFC3280MandatoryAttributeTypesTest7EE.crt
	 InvalidRevokedEETest3EE.crt ValidRFC3280OptionalAttributeTypesTest8EE.crt
	 NoCRLCACert.crt ValidRolloverfromPrintableStringtoUTF8StringTest10EE.crt
	 RevokedsubCACert.crt ValidUTF8StringCaseInsensitiveMatchTest11EE.crt
	 RevokedsubCACRL.crl ValidUTF8StringEncodedNamesTest9EE.crt RFC3280MandatoryAttributeTypesCACert.crt )
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/certs/${testFileName} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/certs/${testFileName} COPYONLY)
ENDFOREACH( testFileName )

add_qca_test(pkits "PublicKeyInfrastructure")

=== unittest/securearrayunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(securearrayunittest_bin_SRCS securearrayunittest.cpp)  

add_executable( securearrayunittest ${securearrayunittest_bin_SRCS} )

target_link_qca_test_libraries(securearrayunittest)

add_qca_test(securearrayunittest "SecureArray")

=== unittest/velox/CMakeLists.txt ===
find_package(Qt${QT_MAJOR_VERSION} COMPONENTS Network REQUIRED)

ENABLE_TESTING()

set(veloxunittest_bin_SRCS veloxunittest.cpp)  

add_executable(veloxunittest ${veloxunittest_bin_SRCS} )

target_link_qca_test_libraries(veloxunittest)
target_link_libraries(veloxunittest Qt${QT_MAJOR_VERSION}::Network)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/root.crt ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/root.crt COPYONLY)

# this will almost always fail.
# add_qca_test(veloxunittest "ServerNameIndication")

=== debian/changelog ===
qca2 (2.3.10-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Update symbols files.
  * Update the patches:
    - pipeunittest_more_wait.diff: refresh
  * Improve the CMakeLists.txt skeleton of the ciphertest autopkgtest:
    - bump the cmake_minimum_required() to 3.18
    - set the CXX language in project()

 -- Pino Toscano <pino@debian.org>  Fri, 14 Mar 2025 05:06:01 +0100

=== debian/control ===
Source: qca2
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: ca-certificates,
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               gnupg <!nocheck>,
               libsasl2-dev,
               libssl-dev (>= 1.1.1~),
               openssl <!nocheck>,
               pkgconf,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.14.0~),
               qt6-base-dev,
               qt6-5compat-dev,
Build-Depends-Indep: doxygen,
                     graphviz,
Build-Conflicts: libqca2-dev, qca-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://userbase.kde.org/QCA
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qca2

Package: libqca-qt5-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates, libqca-qt5-2-plugins
Description: libraries for the Qt Cryptographic Architecture [Qt 5]
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the Qt 5 version.

Package: libqca-qt5-2-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QCA plugins for libqca2 [Qt 5]
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).
 .
 This package contains the Qt 5 versions.

Package: qca-qt5-2-utils
Section: utils
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: command line tool for the Qt Cryptographic Architecture [Qt 5]
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the Qt 5 version of the command line tool for the
 Qt Cryptographic Architecture.

Package: libqca-qt5-2-dev
Section: libdevel
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), qtbase5-dev, ${misc:Depends}
Suggests: libqca2-doc (= ${source:Version})
Description: development files for the Qt Cryptographic Architecture [Qt 5]
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture using Qt 5.

Package: libqca-qt6-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates, libqca-qt6-plugins
Description: libraries for the Qt Cryptographic Architecture [Qt 6]
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the Qt 6 version.

Package: libqca-qt6-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QCA plugins for libqca2 [Qt 6]
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).
 .
 This package contains the Qt 6 versions.

Package: qca-qt6-utils
Section: utils
Architecture: any
Depends: libqca-qt6-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: command line tool for the Qt Cryptographic Architecture [Qt 6]
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the Qt 6 version of the command line tool for the
 Qt Cryptographic Architecture.

Package: libqca-qt6-dev
Section: libdevel
Architecture: any
Depends: libqca-qt6-2 (= ${binary:Version}), qt6-base-dev, ${misc:Depends}
Suggests: libqca2-doc (= ${source:Version})
Description: development files for the Qt Cryptographic Architecture [Qt 6]
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture using Qt 6.

Package: libqca2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: qt5-doc
Suggests: libqca-qt5-2-dev (>= ${source:Version})
Description: API documentation for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains documentation for developers working with the
 Qt Cryptographic Architecture.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden

# Enable strict interdependencies
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

COMMON_CMAKE_ARGS = -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DWITH_botan_PLUGIN=NO -DWITH_gcrypt_PLUGIN=NO -DWITH_nss_PLUGIN=NO -DWITH_pkcs11_PLUGIN=NO

%:
	dh $@ --builddirectory=build

execute_after_dh_auto_clean:
	rm -rf build-qt6

override_dh_auto_configure:
	QT_SELECT=qt5 dh_auto_configure --builddirectory=build -- \
	    $(COMMON_CMAKE_ARGS) \
	    -DQT5_BUILD=ON \
	    -DQCA_FEATURE_INSTALL_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/mkspecs/features"
	dh_auto_configure --builddirectory=build-qt6 -- \
	    $(COMMON_CMAKE_ARGS) \
	    -DBUILD_WITH_QT6=ON \
	    -DQCA_FEATURE_INSTALL_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/qt6/mkspecs/features"

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=build
	dh_auto_build --builddirectory=build-qt6

override_dh_auto_build-indep:
	dh_auto_build --builddirectory=build -- doc
	find build/apidocs/html -name '*.md5' -delete

execute_after_dh_auto_install-arch:
	dh_auto_install --builddirectory=build-qt6

override_dh_auto_install-indep:

override_dh_auto_test-arch:
	QT_PLUGIN_PATH=$(CURDIR)/build/lib/qca-qt5/ dh_auto_test -a
	QT_PLUGIN_PATH=$(CURDIR)/build-qt6/lib/qca-qt6/ dh_auto_test --builddirectory=build-qt6 -a

override_dh_auto_test-indep:

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a

## qca2 2.3.10+p24.04+vunstable+git20250512.0858

=== debian/changelog ===
qca2 (2.3.10+p24.04+vunstable+git20250512.0858-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 12 May 2025 08:58:12 +0000

qca2 (2.3.10-0neon) noble; urgency=medium

  [ Jonathan Riddell ]
  * New release

  [ Neon CI ]
  * New release

 -- Neon CI <neon@kde.org>  Mon, 10 Mar 2025 10:22:28 +0000

qca2 (2.3.8-1) jammy; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Tue, 09 Jan 2024 22:41:59 +0100

qca2 (2.3.5-0neon) UNRELEASED; urgency=medium

  * New release

 -- Jonathan Riddell <jr@jriddell.org>  Fri, 21 Oct 2022 20:11:48 +0100

=== debian/control ===
--- 
+++ 
@@ -1,28 +1,31 @@
 Source: qca2
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Pino Toscano <pino@debian.org>,
+Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: ca-certificates,
-               cmake (>= 3.16~),
+               cmake,
                debhelper-compat (= 13),
                gnupg <!nocheck>,
+               libbotan-2-dev,
+               libgcrypt20-dev,
+               libnss3-dev,
+               libpkcs11-helper1-dev,
                libsasl2-dev,
-               libssl-dev (>= 1.1.1~),
+               libssl-dev,
                openssl <!nocheck>,
+               pkg-kde-tools (>= 0.15.16),
                pkgconf,
-               pkg-kde-tools (>= 0.15.16),
-               qtbase5-dev (>= 5.14.0~),
+               qt6-5compat-dev,
                qt6-base-dev,
-               qt6-5compat-dev,
-Build-Depends-Indep: doxygen,
-                     graphviz,
+               qtbase5-dev
+Build-Depends-Indep: doxygen, graphviz
 Build-Conflicts: libqca2-dev, qca-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://userbase.kde.org/QCA
-Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qca2
+Vcs-Git: https://invent.kde.org/neon/extras/qca2.git
+Vcs-Browser: https://invent.kde.org/neon/extras/qca2
+Maintainer: Neon CI <neon@kde.org>
 
 Package: libqca-qt5-2
 Architecture: any
@@ -89,6 +92,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Breaks: libqca-qt6-2-plugins (<< 2.3.6-3)
+Replaces: libqca-qt6-2-plugins (<< 2.3.6-3)
 Description: QCA plugins for libqca2 [Qt 6]
  This plugin provides cryptographic as well as helper plugins for Qt
  Cryptographic Architecture (QCA).
@@ -112,6 +117,8 @@
 Architecture: any
 Depends: libqca-qt6-2 (= ${binary:Version}), qt6-base-dev, ${misc:Depends}
 Suggests: libqca2-doc (= ${source:Version})
+Breaks: libqca-qt6-2-dev (<< 2.3.6-3)
+Replaces: libqca-qt6-2-dev (<< 2.3.6-3)
 Description: development files for the Qt Cryptographic Architecture [Qt 6]
  The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
  platform API for a range of cryptographic features, including SSL/TLS,
@@ -133,3 +140,17 @@
  .
  This package contains documentation for developers working with the
  Qt Cryptographic Architecture.
+
+Package: libqca-qt6-2-plugins
+Architecture: any
+Multi-Arch: same
+Depends: libqca-qt6-2, ${misc:Depends}, ${shlibs:Depends}
+Description: QCA plugin transitional
+ Dummy empty transitional
+
+Package: libqca-qt6-2-dev
+Architecture: any
+Multi-Arch: same
+Depends: libqca-qt6-dev, ${misc:Depends}, ${shlibs:Depends}
+Description: QCA plugin transitional
+ Dummy empty transitional

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
 include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk
 
-COMMON_CMAKE_ARGS = -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DWITH_botan_PLUGIN=NO -DWITH_gcrypt_PLUGIN=NO -DWITH_nss_PLUGIN=NO -DWITH_pkcs11_PLUGIN=NO
+COMMON_CMAKE_ARGS = -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"
 
 %:
 	dh $@ --builddirectory=build

=== debian/tests/control ===
Tests: acc
Depends: dh-acc, exuberant-ctags, @
Restrictions: allow-stderr

Tests: ciphertest-qt5
Depends: build-essential, cmake, libqca-qt5-2-dev, libqca-qt5-2-plugins

Tests: ciphertest-qt6
Depends: build-essential, cmake, libqca-qt6-dev, libqca-qt6-plugins
